Subject: Re: bug#35864: ~/.local/bin is missing in default PATH on Guix System

From: "pelzflorian (Florian Pelz)" <[email-masked]>
Date: Fri, 24 May 2019 00:36:14 +0200

On Thu, May 23, 2019 at 09:31:09PM +0200, Tobias Geerinckx-Rice wrote:
> pelzflorian (Florian Pelz) wrote:
> > Adding ~/.local/bin to the PATH is common on other distros.
> 
> This is what still needs to be established: is it?  Which ones? Is it merely
> a side-effect of them using systemd?  And most crucially: does it mean that
> Guix needs to add it too?  What about ~/bin?
> 

My motivation was that I would have liked a uniform standard to exist
for offering uniform, simple compilation instructions in tutorials
like mine
<https://pelzflorian.de/gui-prog-gtk-2017/handout-05-meson-en.pdf> or
for how-to-install sections in software project README files.  I
therefore believe such standardization efforts should be supported,
even though Guix has good reason to ignore some other aspects of the
file-system hierarchy standard.

I checked now and systemd Parabola iso images and installed systems do
not include ~/.local/bin; neither does an installed Arch system I
looked at, despite their claim to follow
<https://wiki.archlinux.org/index.php/Frequently_asked_questions#Does_Arch_follow_the_Linux_Foundation's_Filesystem_Hierarchy_Standard_(FHS)?>.
I believe this may have to do with their tendency to ship programs
mostly like their upstream developers ship them, which would apply to
GNU Guix as well.  Many other distributions are discussed at my
stackexchange link from before.

I did not know about ~/bin being conventional, but others mention it
too.  I do not like ~/bin for the reasons you stated:

On Thu, May 23, 2019 at 04:55:28PM +0200, Tobias Geerinckx-Rice wrote:
> My theory is that it's intended for users of graphical file browsers (where
> the traditional ~/bin is a bit too prominent even for my tastes), but I use
> it too.
> 

> I'm was just interested in the (ideally: your) arguments for doing so, not a
> link to a discussion site.  If it really breaks things that should work, I'm
> all in favour of adding it to the default skeleton, if not /etc/profile
> itself.
>

I am not aware of it fixing any breakage, except Python pip according
to the Debian bug report
<https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=820856> (I did not
try to confirm this), but Guix does not (need to?) have a package for
pip anyway.

Regards,
Florian